<?php
if(empty($_SERVER['DOCUMENT_ROOT'])) 
{
	$is_cli=true;
	$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
}

$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once $path.'/Model_esia.php';
include_once $path.'/plugin/report/Model_Report.php';
$rrdpath='/usr/local/esia/public_html/data/rra/';
if(!$is_cli)
{
	include_once '/usr/local/esia/public_html/common.php';
}
$SHORT_OPTS="a:i:s:e:l:";
$LONG_OPTS=array("action:","id:","start:","end:","language:");

if((isset($_POST['blockid']))&&!empty($_POST['blockid'])) // Lors de la modification du bloc
{
	$idInclude= $_POST['blockid'];
	$action= $_GET['action'];
}
elseif((isset($_GET['id'])) &&!empty($_GET['id'])) // Lors de l'ajout du bloc
{
	$idInclude=$_GET['id'];
	$action=$_GET['action'];
}
else // Lors de l'appel par repor_generate.php
{
	$options = getopt($SHORT_OPTS, $LONG_OPTS);
	
	$action	  = getParam($options,"action","a");
	$idInclude= getParam($options,"id","i");
	$language = getParam($options,"language","l");
	$start	  = getParam($options,"start","s");
	$end	  = getParam($options,"end","e");
	
	include $path.'/plugin/report/lang/'.$language.'.php';
	include $path.'/lang/'.$language.'/common_plugin_name.php';
	$datetime1 = new DateTime($start);
	$datetime2 = new DateTime($end);
	$today = new DateTime(date("Y-m-d"));
	$diff = $datetime1->diff($datetime2);
	$interval = $diff ->format('%a');
	
	$diff = $datetime2->diff($today);
	if($diff->format('%a')=="0") // Si date fin du rapport est plus grande ou equale à la date du jour
	{
		$dateFin = "N";
	}
	else // Si choix de date manuel
	{
		$dateFin = $diff ->format('%a');
		$interval = $dateFin + $interval;
		$dateFin = "-".$dateFin."d";
	}
	$interval = "-".$interval."d";
	
	try
	{
		$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
		$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	}
	catch(Exception $e)
	{
		echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
		echo 'N° : '.$e->getCode();
	}
}

$query=Model_Report::getReportIncludeBlock($dbconnection,$idInclude);  
$query= $query[0];

if($action=="generate")
{	
	$param = json_decode($query['include_parameter'],true);
	
	echo '<div class="clear"></div>';
	echo '<section class="blockView">
          	<div class="blockView_title">
          		<h3 style="text-align:'.$param['title']['style']['text-align'].';
						font-size:'.$param['title']['style']['font-size'].';
						color:'.$param['title']['style']['color'].'"
						>'.$param['title']['text'].'</h3>
        	</div>
        	<div class="pad">
          		<p style="text-align:'.$param['description']['style']['text-align'].';
						font-size:'.$param['description']['style']['font-size'].'"
							>'.$param['description']['text'].'</p>';
	echo '<table class="tab">
           	<thead>
             <tr valign="top">';
	
	if($param['affiche_groupNoeud']==true)
	{
		echo '<th><p>'.$lang['REPORT_DEVICE_GROUP_NAME'].'</p></th>';		
	}
	echo '<th><p>'.$lang['REPORT_DEVICE_NAME'].'</p></th>';
	if($param['affiche_type']==true)
	{
		echo '<th><p>'.$lang['REPORT_NODE_TYPE'].'</p></th>';		
	}
	echo '<th><p>'.$lang['REPORT_SERVICE_NAME'].'</p></th>';
	if($param['affiche_message']==true)
	{
		echo '<th><p>'.$lang['REPORT_HAPPEN_MESSAGE'].'</p></th>';
	}
	echo '<th><p>'.$lang['REPORT_VALUE_SERVICE'].'</p></th>';	
	if($param['affiche_MinMax']==true)
	{
		echo '<th><p>'.$lang['REPORT_MINIMUN'].'</p></th>';
		echo '<th><p>'.$lang['REPORT_MAXIMUN'].'</p></th>';
		echo '<th><p>'.$lang['REPORT_DELTA'].'</p></th>';
	}
	echo '</tr>';
	echo '</thead>';
	echo '<tbody>';
	
	if($param['type']=="service" || $param['type']=="groupenoeudplugin")
	{		
		$services_id=array();
		if($param['type']=="groupenoeudplugin")
		{
			foreach ($param['pluginid'] as $id)
			{
				$service = Model_esia::getServiceOfPlugin($dbconnection,$id);
				foreach ($service as $s)
				{						
					$services_id[]=$s['service_id'];
				}
			}
		}
		else
		{
			$services_id=$param['serviceid'];
		}			
		
		foreach ($services_id as $i)
		{					
			$services = Model_esia::getServices($dbconnection,null,$i);
			$services = $services[0];
	
			$services = exctractUnitServiceValue($dbconnection,$services);

			if(!empty($services['value'])&& $services['value']!=null)
			{							
				if($param['affiche_groupNoeud']==true)
				{
					$node = Model_esia::InstanceNode($dbconnection,$services['device_id']);			
					$services['device_group_name']=$node->getGroup();
				}
				if($param['affiche_MinMax']==true)
				{
					$value = getServiceMaxMinValue($dbconnection,$services['id'],$interval,$dateFin,$rrdpath);
					$services['minMax']=$value;
					//print_r($value);
				}
				createelementTab($param,$services,$lang);
			}
			else
			{
				$common_name = Model_esia::getCommonName($lang, $services['name'], $services['check_plugin_name']);
				echo "<tr><td colspan='9'> ERROR ".$services['device_name']." ".$common_name.". </td></tr>";
			}
		}
		echo '</tbody></table></div></section>';
	}
	elseif($param['type']=="groupenoeud" || $param['type']=="noeud")
	{
		$tab_id_node = array();	
			
		if(is_null($user)==false)
		{
			$tab_id_node=nodeOrGroupNode($dbconnection,$param,$user->getId());
		}
		else
		{
			$report_user = Model_Report::getOwnerCanevas($dbconnection,$query['include_canevas_id']);
			$iduser = $report_user;
			$tab_id_node=nodeOrGroupNode($dbconnection,$param,$iduser[0]);
		}
				
		foreach ($tab_id_node as $node)
		{	
			$services = Model_esia::getServices($dbconnection,$node['id'],null);
			foreach ($services as $service)
			{						
				$service = exctractUnitServiceValue($dbconnection,$service);
			
				if(!empty($service['value'])&& $service['value']!=null)
				{
					if($param['affiche_groupNoeud']==true)
					{
						$node = Model_esia::InstanceNode($dbconnection,$service['device_id']);
						$service['device_group_name']=$node->getGroup();
					}
					if($param['affiche_MinMax']==true)
					{
						$value = getServiceMaxMinValue($dbconnection,$service['id'],$interval,$dateFin,$rrdpath);
						$service['minMax']=$value;
						//print_r($value);
					}
					createelementTab($param,$service,$lang);
				}
				else
				{
					$common_name = Model_esia::getCommonName($lang, $service['name'], $service['check_plugin_name']);
					echo "<tr><td colspan='9'> ERROR ".$service['device_name']." ".$common_name.". </td></tr>";
				}
			}
		}
		echo '</tbody></table></div></section>';
	}
}
elseif($action=="update")
{
	$template_path = $path.'/plugin/report/templates/';
	$param = json_decode($query['include_parameter'],true);

	$rightWriting=$_GET['writingright'];	
	if(!isset($rightWriting))
	{
		$rightWriting=$_POST['writingright'];
	}
	$smarty->assign('rightWriting',$rightWriting);
	
	$smarty->assign('block',$query);
	$smarty->assign('param',$param);	
	$taille = explode("px", $param['title']['style']['font-size']);
	$smarty->assign('TaillePoliceTitle',$taille[0]);
	$taille = explode("px", $param['description']['style']['font-size']);
	$smarty->assign('TaillePoliceDescr',$taille[0]);
	$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
	$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
	
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			// Param Title
			$param['title']['text']=$_POST["blockname"];
			$TaillePoliceTitle = $_POST["namesize"];
			$param['title']['style']['font-size']=$TaillePoliceTitle."px";
			$param['title']['style']['text-align']=$_POST["nameposition"];
			$param['title']['style']['color']=$_POST["blockcolor"];
			
			// Param Descr
			$param['description']['text']=$_POST["blockdescription"];
			$TaillePoliceDescr=$_POST["blocksize"];
			$param['description']['style']['font-size']=$TaillePoliceDescr."px";
			$param['description']['style']['text-align']=$_POST["desciptionposition"];
		
			// Service & Noeud
			if($param['type']=='service')
			{
				$param['nodeid']=$_POST['nodes'];
				$param['serviceid']=$_POST['services'];
			}
			elseif ($param['type']=='noeud')
			{
				$param['nodeid']=$_POST['nodes'];
			}
			else
			{
				$param['groupnodeid']=$_POST['groupnodes'];
				$param['pluginid']=$_POST['services'];							
			}
		
			// Affichage colonne			
			$param['affiche_message']=$_POST['messageError'];
			$param['affiche_groupNoeud']=$_POST['groupNoeud'];
			$param['affiche_type']=$_POST['type'];
			$param['affiche_MinMax']=$_POST['MinMAX'];
			$paramSave = json_encode($param);
		
			$query=Model_Report::getReportIncludeBlock($dbconnection,$_POST['blockid']);
			$query= $query[0];

			Model_Report::UpdtReportIncludeBlock($dbconnection,$_POST['blockid'],$query['include_block_id'],$query['include_canevas_id'],$query['include_position'],$paramSave);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		
		$smarty->assign('block',$query);
		$smarty->assign('param',$param);
		$taille = explode("px", $param['title']['style']['font-size']);
		$smarty->assign('TaillePoliceTitle',$taille[0]);
		$taille = explode("px", $param['description']['style']['font-size']);
		$smarty->assign('TaillePoliceDescr',$taille[0]);
		$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
		$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
	}
		
	$listnode = array();
	$listgroupnode = array();
	$listservice = array();
	//Récupération des services
	if($param['type']=="service")
	{
		if(!empty($param['serviceid']))
		{
			$services = Model_esia::getServices($dbconnection,null,$param['serviceid']);		
			foreach($services as $ser)
			{
				if(!in_array($ser['device_id'],$listnode))
					$listnode[]=$ser['device_id'];
			}
			foreach($services as $ser)
			{
				$listservice[]=$ser['id'];
			}
		}
		$smarty->assign('serviceid',$listservice);
		
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();

		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$listnode))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected			
			);
		}
	}
	elseif($param['type']=="noeud")
	{
		//Récupération des noeuds
		$nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
		$list=array();
		foreach($nodes as $node)
		{
			$selected='no';
			if(in_array($node->getId(),$param['nodeid']))
			{
				$selected='yes';
			}
			$list[]=array('id'=>$node->getId(),
					'name'=>$node->getGroup().'>'.$node->getName(),
					'selected'=>$selected					
			);
		}
	}
	elseif($param['type']=="groupnoeud")
	{
		$list = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
		$list_group_node=array();
		foreach($list as $node)
		{
			$selected='no';
			if(in_array($node['id'],$param['groupnodeid']))
			{
				$selected='yes';
			}
				
			$list_group_node[]=array('id'=>$node['id'],
					'name'=>$node['name'],
					'selected'=>$selected);
		}
	}
	else
	{
		if(!empty($param['pluginid']))
		{			
			$plugins = Model_esia::getPluginOfGroupNode($dbconnection,null,$param['pluginid'],$user->getId());	
			/*foreach ($plugins as $plugin)
			{
				if(!in_array($plugin['device_group_id'],$listgroupnode))
					$listgroupnode[]=$plugin['device_group_id'];
			}*/
			foreach($plugins as $plugin)
			{
				$listservice[]=$plugin['id'];
			}		
		}
		$arr_unique=array();
		$arr_unique=array_unique($listservice);
		$listservice=array();
		foreach ($arr_unique as $val)
		{
			$listservice[]=$val;
		}
		$smarty->assign('serviceidgroup',$listservice);
		
		$list = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
		$list_group_node=array();
		foreach($list as $node)
		{
			$selected='no';
			if(in_array($node['id'],$param['groupnodeid']))
			{
				$selected='yes';
			}
				
			$list_group_node[]=array('id'=>$node['id'],
					'name'=>$node['name'],
					'selected'=>$selected);
		}
	}
	$smarty->assign('adm_list_node',$list);
	$smarty->assign('adm_list_group_node', $list_group_node);
	$smarty->assign('action','update');
	$smarty->display($template_path.'value_service.html');
}
elseif($action =="getservicenoeud")
{
	$template_path = $path.'/plugin/report/templates/';
	if(isset($_GET['nodeid']))
	{
		$tablenodeid = json_decode($_GET['nodeid']);
		$list=array();				
		
		foreach($tablenodeid as $nodeid)
		{			
			$node = Model_esia::InstanceNode($dbconnection, $nodeid);			
			if($user->getAccess($dbconnection, "device_view",$node->getName())==1)
			{
				$services = Model_esia::getServices($dbconnection,$node->getId());
				foreach ($services as $service)
				{
					$list[$service['id']]=$node->getName().' > '.$service['name'];
				}
			}
		}
		echo json_encode($list);
		exit(0);
	}
}
elseif ($action=="getserviceofgroupnode")
{
	$template_path = $path.'/plugin/report/templates/';
	if(isset($_GET['groupnodeid']))
	{		
		$tablegroupnodeid = json_decode($_GET['groupnodeid']);
		$list=array();	
		foreach($tablegroupnodeid as $groupnodeid)
		{
			$plugins = Model_esia::getPluginOfGroupNode($dbconnection, $groupnodeid,null,$user->getId());
			foreach ($plugins as $plugin)
			{
				$list[$plugin['id']]=$plugin['name'];				
			}
		}	
		$list=array_unique($list);
		echo json_encode($list);
		exit(0);
	}
}

function exctractUnitServiceValue($dbconnection,$service)
{
	$ret = null;		
	$value=$service['value'];
	if(!empty($value) && $value!=null)
	{
		ksort($value,SORT_STRING|SORT_FLAG_CASE);
		foreach ($value as $key=>$val)
		{
			$unit = Model_esia::getRrdPlugin($dbconnection,$service['plugin_id'],$key);	
			if($unit=='percent')$unit='%';
			elseif($unit=='Bytes')$unit='MB';
			elseif ($unit=='temperature')$unit='°C';
			elseif ($unit=='Celsius')$unit='°C';
			elseif ($unit=='number'||$unit=='LINE1'||$unit=='AREA')$unit='';
			$value_service = $service['value'][$key];
			if ($key=='temperature_cpu1')$key='temperature cpu';
			elseif ($key=='temperature_sys')$key='temperature system';
			$ret = $ret."  ".ucfirst($key)." : ".$value_service." ".$unit." <br> ";
			//$ret[] = ucfirst($key)." : ".$service['value'][$key]." ".$unit." <br>";
		}				
		$service['value']=rtrim($ret,' <br> ');
		//$service['value']=$ret;
		$service['stdout'] = explode('\|',$service['stdout']);
		$service['stdout']=$service['stdout'][0];
	}
	else
	{		
		$service['value']="NO DATA";		
	}
	
	$ret=$service;	
	return $ret;
}


/**
 * @brief fais la difference entre noeud et groupe de noeud et retourne les bons param's
 * @detail retourne un array contenant les paramètres utlisés qu'importe que ce soit un noeud ou groupe de noeud
 * @param PDO $dbconnection
 * @param array $param contient les param du block
 * @retval unknown[][]|NULL[][]
 * @throw void
 */

function nodeOrGroupNode($dbconnection,$param,$userid)
{
	$tab_id_node=array();
	if($param['type']=="noeud")
	{
		foreach($param['nodeid'] as $val)
		{
			$node=Model_esia::InstanceNode($dbconnection,$val);
			$tab_id_node[] = array('id'=>$val,'parent'=>$node->getGroup(),'ip'=>$node->getIPAddress());
		}
	}
	else
	{
		foreach ($param['groupnodeid'] as $groupnode )
		{
			$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$groupnode);
			//$tab_group_node = Model_esia::getNodeList($dbconnection,null,$groupnode,$t_return = Model_esia::NODE_INSTANCE);
			foreach ($tab_group_node as $node)
			{
				$tab_id_node[] = array('id'=>$node->getId(),'parent'=>$node->getGroup(),'idgroup'=>$node->getGroupId(),'ip'=>$node->getIPAddress());
			}
		}
	}
	return $tab_id_node;
}
/**
 @brief retourne le code html d'incident
 @params array $param contient les paramètres de l'includeblock
 @params array $query liste des erreurs des services
 @params array $lang contient les traductions
 */

function createelementTab($param,$services,$lang)
{
	$common_name = Model_esia::getCommonName($lang, $services['name'], $services['check_plugin_name']);
		
	echo '<tr>';
	if($param['affiche_groupNoeud']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$services['device_group_name'].'</p></td>';
	}
	echo'<td><p style="word-wrap:break-word">'.$services['device_name'].'</p></td>';
	if($param['affiche_type']==true)
	{
		echo'<td><p style="word-wrap:break-word">'.$services['device_type'].'</p></td>';
	}	 
	
	echo'<td><p style="word-wrap:break-word;font-size:10px";>'.str_replace('_',' ',$common_name).'</p></td>';	
	if($param['affiche_message']==true)
	{
		echo'<td><p style="word-wrap:break-word;font-size:10px";>'.$services['stdout'].'</p></td>';
	}
	echo'<td><p style="word-wrap:break-word">'.$services['value'].'</p></td>';
	if($param['affiche_MinMax']==true)
	{
		echo'<td><p style="word-wrap:break-word;font-size:10px";>';
		foreach($services['minMax'] as $key => $line )
		{
			if($line['unit'] =='B')
			{
				echo formatBytes($line['min'],2).'<br />';
			}
			else 
			{
				echo $line['min'].$line['unit'].'<br />';
			}
		}
		echo'</td>';
		echo'<td><p style="word-wrap:break-word;font-size:10px";>';
		foreach($services['minMax'] as $key => $line )
		{
			if($line['unit'] =='B')
			{
				echo formatBytes($line['max'],2).'<br />';
			}
			else
			{
				echo $line['max'].$line['unit'].'<br />';
			}
		}
		echo'</td>';
		echo'<td><p style="word-wrap:break-word;font-size:10px";>';
		foreach($services['minMax'] as $key => $line )
		{
			if($line['unit'] =='B')
			{
				echo formatBytes($line['delta'],2).'<br />';
			}
			else
			{
				echo $line['delta'].$line['unit'].'<br />';
			}
		}
		echo'</td>';
	}
	/*if($services['state']==0)
	{
		echo'<td><p style="word-wrap:break-word">'.$services['value'].'</p></td>';
	}
	elseif($services['state']==1)
	{
		echo'<td><p class="EventWarning_Incident" style="word-wrap:break-word">'.$services['value'].'</p></td>';
	}
	elseif($services['state']==2)
	{
		echo'<td><p class="EventCritical_Incident" style="word-wrap:break-word">'.$services['value'].'</p></td>';
	}
	elseif($services['state']==3)
	{
		echo'<td><p class="EventUnknown_Incident" style="word-wrap:break-word">'.$services['value'].'</p></td>';
	}*/	
	echo '</tr>';
}
/**
 @brief retourne la valeur associé à la clé
 @detail retourne la valeur associé au paramètre. ou une valeur par défaut
 @params array $options le tableau de paramètre global
 @params string $name1 le nom court du paramètre (ex: -H 127.0.0.1)
 @params string $name2 le nom long du paramètre (ex: --host 127.0.0.1)
 @params string $default (optionnel) la valeur par défaut du paramètre s'il n'est pas spécifié
 @retval	null|mixed la valeur du paramètre
 @throw void
 */
function getParam($options,$name1,$name2,$default=null)
{
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}
/**
 @brief retourne la valeur en % moyenne du service
 @detail retourne en pourcentage la valeur du service
 @params int $service_id l'identifiant du service
 @params string $interval nombre de jour de décalage (ex: -30d)
 @params string $dateFin Soit N si c'est aujourd'hui ou alors -'x'd  (x = valeur nombre de jour)
 @params string $rrdpath path pour les rrd
 @retval	int la valeur du service (%)
 @throw void
 */

function getServiceMaxMinValue($dbconnection,$service_id,$interval,$dateFin,$rrdpath)
{
	$query= $dbconnection->prepare("SELECT service_id,service_name,service_parameter,service_last_stdout,device_name,plugin_name,
								rrd_type,rrd_regex,rrd_time,rrd_name,rrd_max,rrd_min,rrd_vertical_label,rrd_graph_color,rrd_graph_type,rrd_regex_threshold,rrd_graph_num
							FROM esia_services
							JOIN esia_device ON device_id = service_device_id
							JOIN esia_plugins ON plugin_id = service_plugin_id
							JOIN rrd_plugins ON rrd_plugin_id=service_plugin_id WHERE service_id=? ORDER BY rrd_graph_type,rrd_name;");
	$ret = $query->execute(array($service_id));
	if($ret===false)
	{
		$err = $query->errorInfo();
		echo "DB error: ".$err[2]."\n";
	}
	$arr_rrd=$query->fetchAll(PDO::FETCH_OBJ);
	//liste les information pour générer le graphique et les sépares suivant leurs numéros (clé rrd_graph_num)
	$list_file=array();
	$data = array();
	foreach($arr_rrd as $row)
	{
		$filename = $rrdpath.$row->device_name.'_'.$row->plugin_name.$row->service_id.$row->rrd_graph_num.'.rrd';
		if(is_file($filename) && !in_array($filename, $list_file))
		{
			$list_file[]=$filename;
			$ret = rrd_fetch($filename, array( "AVERAGE", "--start",$interval, "--end",$dateFin));
			foreach($ret['data'] as $key => $rrddata)
			{
				$min=null;
				$max=null;
				foreach($rrddata as $value)
				{
					if(stristr($value,'NAN')==FALSE)
					{
						if($min == null && $max ==null)
						{
							$min = $value;
							$max = $value;
						}
						if($value < $min)
						{
							$min = $value;
						}
						if($value > $max)
						{
							$max = $value;
						}
					}
				}
				$unit = $row->rrd_vertical_label;
				if($unit=='percent')$unit='%';
				elseif($unit=='Bytes')$unit='B';
				elseif ($unit=='temperature')$unit='°C';
				elseif ($unit=='Celsius')$unit='°C';
				elseif ($unit=='number'||$unit=='LINE1'||$unit=='AREA')$unit='';
				
				$data[strtolower($key)]=array('min'=>round($min,2),'max'=>round($max,2),'delta'=>round($max - $min,2),'unit'=>$unit);
			}
		}
	}
	ksort($data);
	return $data;
}
function formatBytes($bytes, $precision = 2) {
	$units = array('', 'KB', 'MB', 'GB', 'TB');
	$base = log($bytes, 1024);
	return round(pow(1024, $base - floor($base)), $precision) .' '. $units[floor($base)];
} 
?>
