<?php
if(empty($_SERVER['DOCUMENT_ROOT'])) 
{
	$is_cli=true;
	$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
}

$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
include_once $path.'/plugin/report/Model_Report.php';

if(!$is_cli)
{
	include_once '/usr/local/esia/public_html/common.php';
}
$SHORT_OPTS="a:i:s:e:l:";
$LONG_OPTS=array("action:","id:","start:","end:","language:");

if((isset($_POST['blockid']))&&!empty($_POST['blockid'])) // Lors de la modification du bloc
{
	$idInclude= $_POST['blockid'];
	$action= $_GET['action'];
}
elseif((isset($_GET['id'])) &&!empty($_GET['id'])) // Lors de l'ajout du bloc
{
	$idInclude=$_GET['id'];
	$action=$_GET['action'];
}
else // Lors de l'appel par repor_generate.php
{
	$options = getopt($SHORT_OPTS, $LONG_OPTS);
	
	$action	  = getParam($options,"action","a");
	$idInclude= getParam($options,"id","i");
	$language = getParam($options,"language","l");
	
	include $path.'/plugin/report/lang/'.$language.'.php';
	include $path.'/lang/'.$language.'/common_plugin_name.php';
	
	try
	{
		$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
		$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	}
	catch(Exception $e)
	{
		echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
		echo 'N° : '.$e->getCode();
	}
}

$query=Model_Report::getReportIncludeBlock($dbconnection,$idInclude);  
$query= $query[0];

if($action=="generate")
{	
	$param = json_decode($query['include_parameter'],true);
	
	echo '<div class="clear"></div>';
	echo '<section class="blockView">
          	<div class="blockView_title">
          		<h3 style="text-align:'.$param['title']['style']['text-align'].';
						font-size:'.$param['title']['style']['font-size'].';
						color:'.$param['title']['style']['color'].'"
						>'.$param['title']['text'].'</h3>
        	</div>
        	<div class="pad">
          		<p style="text-align:'.$param['description']['style']['text-align'].';
						font-size:'.$param['description']['style']['font-size'].'"
							>'.$param['description']['text'].'</p>';
	echo '<table class="tab">
           	<thead>
             <tr valign="top">';
	
	echo '<th><p>'.$lang['REPORT_GPDR_ID'].'</p></th>';
    echo '<th><p>'.$lang['REPORT_USER_MAIL'].'</p></th>';
    echo '<th><p>'.$lang['REPORT_GPDR_DATE'].'</p></th>';
    echo '<th><p>'.$lang['REPORT_GPDR_ACTION'].'</p></th>';
    echo '<th><p>'.$lang['REPORT_GPDR_TYPE'].'</p></th>';   
    echo '<th><p>'.$lang['REPORT_BLOCK_DESCRIPTION'].'</p></th>';    
	echo '<th><p>'.$lang['REPORT_GPDR_MESSAGE'].'</p></th>';
	echo '</tr>';
	echo '</thead>';
	echo '<tbody>';
	
	$param = Model_adm::getGDPRRegister($dbconnection);
	createelementTab($param,$lang);
	echo '</tbody></table></div></section>';
}
elseif($action=="update")
{
	$template_path = $path.'/plugin/report/templates/';
	$param = json_decode($query['include_parameter'],true);

	$rightWriting=$_GET['writingright'];	
	if(!isset($rightWriting))
	{
		$rightWriting=$_POST['writingright'];
	}
	$smarty->assign('rightWriting',$rightWriting);
	
	$smarty->assign('block',$query);
	$smarty->assign('param',$param);	
	$taille = explode("px", $param['title']['style']['font-size']);
	$smarty->assign('TaillePoliceTitle',$taille[0]);
	$taille = explode("px", $param['description']['style']['font-size']);
	$smarty->assign('TaillePoliceDescr',$taille[0]);
	$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
	$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
	
	if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
	{
		try
		{
			// Param Title
			$param['title']['text']=$_POST["blockname"];
			$TaillePoliceTitle = $_POST["namesize"];
			$param['title']['style']['font-size']=$TaillePoliceTitle."px";
			$param['title']['style']['text-align']=$_POST["nameposition"];
			$param['title']['style']['color']=$_POST["blockcolor"];
			
			// Param Descr
			$param['description']['text']=$_POST["blockdescription"];
			$TaillePoliceDescr=$_POST["blocksize"];
			$param['description']['style']['font-size']=$TaillePoliceDescr."px";
			$param['description']['style']['text-align']=$_POST["desciptionposition"];
			
			// Affichage colonne			
			$param['affiche_message']=$_POST['messageError'];
			$param['affiche_groupNoeud']=$_POST['groupNoeud'];
			$param['affiche_type']=$_POST['type'];
					
			$paramSave = json_encode($param);
		
			$query=Model_Report::getReportIncludeBlock($dbconnection,$_POST['blockid']);
			$query= $query[0];

			Model_Report::UpdtReportIncludeBlock($dbconnection,$_POST['blockid'],$query['include_block_id'],$query['include_canevas_id'],$query['include_position'],$paramSave);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
		
		$smarty->assign('block',$query);
		$smarty->assign('param',$param);
		$taille = explode("px", $param['title']['style']['font-size']);
		$smarty->assign('TaillePoliceTitle',$taille[0]);
		$taille = explode("px", $param['description']['style']['font-size']);
		$smarty->assign('TaillePoliceDescr',$taille[0]);
		$smarty->assign('AlignTilte',$param['title']['style']['text-align']);
		$smarty->assign('AlignDesc',$param['description']['style']['text-align']);
	}		
	$smarty->assign('action','update');
	$smarty->display($template_path.'block_gpdr.html');
}

/**
 @brief retourne le code html d'incident
 @params array $param contient les paramètres de l'includeblock
 @params array $query liste des erreurs des services
 @params array $lang contient les traductions
 */

function createelementTab($param,$lang)
{
	foreach ($param as $p) 
	{
		echo '<tr>';
		echo'<td><p style="word-wrap:break-word">'.$p['id'].'</p></td>';
		echo'<td><p style="word-wrap:break-word">'.$p['user'].'</p></td>';
		echo'<td><p style="word-wrap:break-word">'.$p['date'].'</p></td>';
		echo'<td><p style="word-wrap:break-word">'.$p['action'].'</p></td>';
		echo'<td><p style="word-wrap:break-word">'.$p['type'].'</p></td>';
		echo'<td><p style="word-wrap:break-word">'.$p['data'].'</p></td>';
		echo'<td><p style="word-wrap:break-word">'.$p['finality'].'</p></td>';
		echo '</tr>';
	}
}
/**
 @brief retourne la valeur associé à la clé
 @detail retourne la valeur associé au paramètre. ou une valeur par défaut
 @params array $options le tableau de paramètre global
 @params string $name1 le nom court du paramètre (ex: -H 127.0.0.1)
 @params string $name2 le nom long du paramètre (ex: --host 127.0.0.1)
 @params string $default (optionnel) la valeur par défaut du paramètre s'il n'est pas spécifié
 @retval	null|mixed la valeur du paramètre
 @throw void
 */
function getParam($options,$name1,$name2,$default=null)
{
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}

?>
